/*
 * ACME - a crossassembler for producing 6502/65c02/65816 code.
 * Copyright (C) 1998 Marco Baye
 * Have a look at "acme.c" for further info
 */

#ifndef platform_H
#define platform_H

/*
 * Platform specific stuff (in this case, for DOS)
 */

typedef short       Sixteen;/* At least 16 bit */
typedef signed long Value;  /* At least 32 bit */

#define PLATFORM_VERSION "Ported to OS/2 by Malte Eckhardt.\n"

#define PORT_SWITCHES


/* Integer-to-character conversion routine */
#define PLATFORM_INT2CHAR(x)    \
  x ^= x >>  8;                 \
  x &= 255


/* Closedown sequence */
#define PLATFORM_EXIT

/* Convert UNIX-style pathname to system-style pathname */
#define PLATFORM_CONVERTPATH(a) Platform_ConvertPath(a)

/* Platform specific message output */
#define PLATFORM_MESSAGE(a, b)

/* Maximum length of filenames in sources */
#define LNFMAX          255

/* Maximum length of paths */
#define LNPMAX          4096

/* Setting the created files' types */
#define PLATFORM_SETFILETYPE(a, b)

/* Platform specific command line switches */
#define PLATFORM_SWITCHCODE

/*
 * Prototypes
 */
static void Platform_FindLib(void);
static void Platform_ConvertPath(char *);

#endif
